
import java.awt.*;
import java.util.*;
import java.lang.*;
import java.io.*;

public class Graph_plot_ratio_all extends Frame {
  Button closeButton;  // button to close the window
  int width = 800, height = 800;  // height and width of window
  int x_origin = 80, y_origin = height - 80;  // x and y origins of the graph
  int graph_xsize = width - 150, graph_ysize = height - 150;  // size of x and y axis
  int show_country;
  double Global_ratio[];
  int Infected_cycle[];
  
  static double sim_ratio[];
  static double real_case[];
  static double real_ratio[];
  static double sort_data[];
  static int sort_data_num[];
  
  static int standard_country;
  static int total_country;  // number of values to plot
  static String origin;
  
  public Graph_plot_ratio_all(){
    setSize(width, height);
    setLayout(null);
    setTitle("Ratio");
  }

  public Graph_plot_ratio_all(int a, int b, double data[], double data2[], int data3[]){
    this();

    int i;
    
    total_country = a;
    standard_country = b;
    show_country = total_country;
    
    sim_ratio = new double[total_country];
    real_case = new double[total_country];
    real_ratio = new double[total_country];
    sort_data = new double[total_country];
    sort_data_num = new int[total_country];
    Global_ratio = new double[total_country];
    Infected_cycle = new int[total_country];
    
    sim_ratio = data;
    sort_data = real_ratio;
    Global_ratio = data2;
    Infected_cycle = data3;
    
    for(i = 0; i < total_country; i++){
      sort_data_num[i] = i;
    }
    
    input_data();

    for(i = 0; i < total_country; i++){
      origin = return_area_name(i);
      System.out.println(origin + ": Real: " + real_ratio[i] + ": Sim: " + sim_ratio[i] + ": Per GL: " + (100 * Global_ratio[i]));
    }

    selection_sort(total_country - 1);
    show();
  }
  
  public void selection_sort(int last_num){
    int i, j;

    double temp_min_data = sort_data[0];
    int temp_min_num = 0;
    
    for(i = 0; i <= last_num; i++){
      if(temp_min_data > sort_data[i]){
        temp_min_num = i;
        temp_min_data = sort_data[i];
      }
    }
    exchange(temp_min_num, last_num);
    if(last_num - 1 > 0){
      selection_sort(last_num - 1);
    }
  }

  public void exchange(int min_num, int last_num){
    double temp_double;
    int temp_int;

    temp_double = sort_data[last_num];
    sort_data[last_num] = sort_data[min_num];
    sort_data[min_num] = temp_double;

    temp_int = sort_data_num[last_num];
    sort_data_num[last_num] = sort_data_num[min_num];
    sort_data_num[min_num] = temp_int;

    //sort_check();
  }
  
  public void sort_check(){
    int i;

    for(i = 0; i < total_country; i++){
      origin = return_area_name(sort_data_num[i]);
      System.out.println(i + ": " + origin + ": " + sort_data_num[i] + ": " + sort_data[i]);
    }
  }
  
  public void paint(Graphics g) {
    int i, j;
    double maxvalue;  // max integer values to plot
    double xinterval;  // number of pixels between each value on x-axis
    double yinterval, ystep;  // number of pixels between each value on y-axis and that value
    Color dotColor;  // color of the dot

    int ysize;
    
    ysize = graph_ysize;
    g = getGraphics();

    
    maxvalue = sim_ratio[0];
    
    /* determine x-interval */
    xinterval = (double)graph_xsize / show_country;
 
    /* determine y-interval */
    if((double)maxvalue / 4 <= 0.25){
      yinterval = (double)ysize/1;
      ystep = 0.25;
    }
    else if((double)maxvalue / 4 <= 1){
      yinterval = (double)ysize/4;
      ystep = 1;
    }
    else if((double)maxvalue / 4 <= 5){
      yinterval = (double)ysize/20;
      ystep = 5;
    }
    else if((double)maxvalue /4 <= 25) {
      yinterval = (double)ysize/100;
      ystep = 25;
    }
    else{
      yinterval = (double)ysize/400;
      ystep = 100;
    }

    yinterval = (double)ysize/0.1;
    ystep = 0.025;

    g.setColor(Color.black);
    g.drawLine(620,90,720,90);
    g.drawLine(620,90,620,170);
    g.drawLine(720,90,720,170);
    g.drawLine(620,170,720,170);

    g.setColor(Color.red);
    g.drawString("REAL",670,118);
    g.fillRect(650, 105, 10, 15);
    
    g.setColor(Color.blue);
    g.drawString("SIM", 670, 158);
    g.fillRect(650, 145, 10, 15);
    
    /* draw axis */
    g.setColor(Color.black);
    g.drawLine(x_origin, y_origin, x_origin + graph_xsize, y_origin);
    g.drawLine(x_origin, y_origin, x_origin, y_origin - graph_ysize);
    g.drawLine(x_origin + graph_xsize, y_origin, x_origin + graph_xsize, y_origin - graph_ysize);
    g.drawString(String.valueOf(0), x_origin - 20, y_origin + 20);
    
    for(i = 1; i <= 4; i++) {
      g.drawString(String.valueOf(ystep * i), x_origin - 60, y_origin - (i * graph_ysize / 4));
      g.drawLine(x_origin, y_origin - (i * graph_ysize / 4), x_origin + graph_xsize, y_origin - (i * graph_ysize / 4));
    }
    for(i = 0; i < show_country; i++){
      g.drawString(return_area_name(sort_data_num[i]), (int)(x_origin + (xinterval * (i))), y_origin + 20);
      g.drawString(String.valueOf(Infected_cycle[sort_data_num[i]]), (int)(x_origin + (xinterval * (i))), y_origin + 40);
    }
    
    /* plot the graph */
    double bar_width = xinterval * 0.2;
    g.setColor(Color.red);
    for(i = 0; i < show_country; i++){
      g.fillRect((int)(x_origin + (xinterval * i) + bar_width), (int)(y_origin - (sort_data[i] * yinterval)), (int)bar_width, (int)(sort_data[i] * yinterval + 1));
    }
    g.setColor(Color.blue);
    for(i = 0; i < show_country; i++){
      g.fillRect((int)(x_origin + (xinterval * i) + (bar_width * 2)), (int)(y_origin - (sim_ratio[sort_data_num[i]] * yinterval)), (int)bar_width, (int)(sim_ratio[sort_data_num[i]] * yinterval + 1));
    }
    g.setColor(Color.green);
    for(i = 0; i < show_country; i++){
      g.fillRect((int)(x_origin + (xinterval * i) + (bar_width * 3)), (int)(y_origin - (sim_ratio[sort_data_num[i]] * yinterval * Global_ratio[sort_data_num[i]])), (int)bar_width, (int)(sim_ratio[sort_data_num[i]] * yinterval * Global_ratio[sort_data_num[i]] + 1));
    }
    g.setColor(Color.blue);
    for(i = 0; i < show_country; i++){
      g.fillRect((int)(x_origin + (xinterval * i) + (bar_width * 3)), (int)(y_origin - (sim_ratio[sort_data_num[i]] * yinterval)), (int)bar_width, (int)(sim_ratio[sort_data_num[i]] * yinterval * (1 - Global_ratio[sort_data_num[i]]) + 1));
    }
  }
  
  public static String return_area_name(int i){
    String area_name;
    
    switch(i){
    case 0:
      area_name = "CH";
      break;
    case 1:
      area_name = "HK";
      break;
    case 2:
      area_name = "TW";
      break;
    case 3:
      area_name = "CA";
      break;
    case 4:
      area_name = "PH";
      break;
    case 5:
      area_name = "SG";
      break;
    case 6:
      area_name = "VN";
      break;
    case 7:
      area_name = "AU";
      break;
    case 8:
      area_name = "FR";
      break;
    case 9:
      area_name = "GR";
      break;
    case 10:
      area_name = "IN";
      break;
    case 11:
      area_name = "ID";
      break;
    case 12:
      area_name = "IR";
      break;
    case 13:
      area_name = "IT";
      break;
    case 14:
      area_name = "JP";
      break;
    case 15:
      area_name = "KR";
      break;
    case 16:
      area_name = "KW";
      break;
    case 17:
      area_name = "MA";
      break;
    case 18:
      area_name = "ML";
      break;
    case 19:
      area_name = "MO";
      break;
    case 20:
      area_name = "NZ";
      break;
    case 21:
      area_name = "RO";
      break;
    case 22:
      area_name = "RU";
      break;
    case 23:
      area_name = "SA";
      break;
    case 24:
      area_name = "SP";
      break;
    case 25:
      area_name = "SW";
      break;
    case 26:
      area_name = "SZ";
      break;
    case 27:
      area_name = "TH";
      break;
    case 28:
      area_name = "UK";
      break;
    case 29:
      area_name = "US";
      break;
    default:
      area_name = "ERROR";
      break;
    }
    return area_name;
  }

  public boolean handleEvent(Event event) {
    if(event.target == closeButton && event.id == Event.ACTION_EVENT) {
      hide();
      dispose();
      return true;
    }
    if (event.id == Event.WINDOW_DESTROY) {
      hide();
      dispose();
      return true;
    }
    return super.handleEvent(event);
  }

  public static void input_data() { 
    int i = 0;
    String line;

    try{
      FileReader inFile = new FileReader("Data/Real_Case.txt");
      BufferedReader inBuffer = new BufferedReader(inFile);

      i = 0;
      while((line = inBuffer.readLine()) != null) {
        real_case[i] = Double.parseDouble(line);
        i++;
      }
      inBuffer.close();
    }
    catch(IOException e) {
    }

    for(i = 0; i < total_country; i++){
      real_ratio[i] = (double)((double)real_case[i]/(double)real_case[standard_country]);
      
    }
  }
}