import java.util.*;
import java.lang.*;
import java.io.*;

class Network{

  //PARAMETERS-------------------------------------------------

  //GENERAL------------------------
  static int total_country = 35; //Number of Countries or Regions
  static int runcycle = 100; //Runcycle
  
  static int origin_1 = 6; //Initial Infected Country 1
  static int initial_case = 1; //Number of First Cases in Origin
  static int standard_country = 6; //Country of standard for ratio
  
  static double travelers[][] = new double[total_country][total_country];
  static int current_cycle;
  static String origin;
  static String destination;
  static boolean actual_timing = false; //Whether consider actual timing of first infection in each country
  
  //GLOBAL INFECTION-------------------------
  static double global_prob_1 =   0.0000002; //Global Infection Prob for Travelers
  static double global_deductor = 0.000000005; //Global Infection Deduction
  
  //LOCAL INFECTION-------------------------
  static double local_prob[][] = new double[total_country][runcycle + 1]; //Local Infection Prob
  static double local_deductor = 0.00000025; //Local Infection Deduction

  static double c1 = 0.000000007225; //for slop
  static double c2 = 0.000007692; //for intersection
  
  static int incubation_period = 10;
  static int infection_period = 10;
  
  static double area[] = new double[total_country]; //area
  static double pop[] = new double[total_country]; //pop
  static double density[] = new double[total_country]; //density

  static double Susceptible[][] = new double[total_country][runcycle + 1];
  static double Exposed[][] = new double[total_country][runcycle + 1];
  static double Infected[][] = new double[total_country][runcycle + 1];
  static double Recovered[][] = new double[total_country][runcycle + 1];

  static double Cumulative[][] = new double[total_country][runcycle + 1];
  static double new_Exposed[][] = new double[total_country][runcycle + 1];
  static double new_Infected[][] = new double[total_country][runcycle + 1];

  static double Infected_by_local[] = new double[total_country];
  static double Infected_by_global[] = new double[total_country];
  
  static int infected_cycle[] = new int[total_country];
  static int infected_from[] = new int[total_country];
  static boolean infected_already[] = new boolean[total_country];
  static double Ratio[] = new double[total_country];

  //special for three countries
  static double Cumulative_30[][] = new double[30][runcycle + 1];
  static double Infected_30[][] = new double[30][runcycle + 1];
  static double Ratio_30[] = new double[30];

  static double Global_ratio[] = new double[total_country];
  static double Global_ratio_30[] = new double[30];
  static int Infected_cycle_30[] = new int[30];
  
  public static void main(String args[]){
    
    input_num();
    init();
    
    sim();
        
    plot_graphs();
  }

  //INITIALIZATION
  public static void init(){
    int i, j;
    
    for(i = 0; i < total_country; i++){
      for(j = 0; j <= runcycle; j++){
        Susceptible[i][j] = pop[i];
        Infected[i][j] = 0;
        Recovered[i][j] = 0;
        Exposed[i][j] = 0;
        Cumulative[i][j] = 0;
        new_Exposed[i][j] = 0;
        new_Infected[i][j] = 0;
      }
    }
    for(i = 0; i < total_country; i++){
      if(actual_timing == false){
        infected_cycle[i] = -1;
      }
      infected_from[i] = -1;
      infected_already[i] = false;
    }
    
    Exposed[origin_1][0] = initial_case;
    Susceptible[origin_1][0] = Susceptible[origin_1][0] - Exposed[origin_1][0];
    Infected[origin_1][0] = 0;
    Recovered[origin_1][0] = 0;
    new_Exposed[origin_1][0] = initial_case;
    new_Infected[origin_1][0] = 0;
    infected_cycle[origin_1] = 0;
    infected_already[origin_1] = true;
    Cumulative[origin_1][0] = 0;

  }

  //LOCAL INFECTION
  public static int local_infection(int country, int current_cycle){
    int temp_case = 0; 

    if(Susceptible[country][current_cycle - 1] > 0 && Infected[country][current_cycle - 1] > 0){
      temp_case = (int)(calc_local_prob(country, current_cycle) * Susceptible[country][current_cycle - 1] * Infected[country][current_cycle - 1]);
    }
    else{
      temp_case = 0;
    }
    
    return temp_case;
  }

  public static double calc_local_prob(int country, int current_cycle){
    double result;
    result = (local_prob[country][current_cycle] - calc_local_deduction(current_cycle));
    if(result < 0){
      return 0;
    }
    else{
      return result;
    }
  }

  public static double calc_local_deduction(int current_cycle){
    return (local_deductor * current_cycle);
  }

  //GLOBAL INFECTION
  static int global_infection(int country, int current_cycle){
    if(current_cycle == infected_cycle[country]){
      infected_already[country] = true;
      return 1;
    }
    else if(current_cycle < infected_cycle[country]){
      return 0;
    }
    else{
      int pertner;
      int temp_case = 0;
      
      double temp_global_deductor = calc_global_deduction(current_cycle);
      origin = return_area_name(country);
      
      for(pertner = 0; pertner < total_country; pertner++){
        if(country != pertner){
          if(infected_cycle[pertner] != current_cycle){
            temp_case = (int)(temp_case + (long)((global_prob_1 - temp_global_deductor) * Infected[pertner][current_cycle - 1] * travelers[pertner][country]));
            if(infected_already[country] == false){
              
              if(temp_case >= 1){
                
                if(Cumulative[country][current_cycle - 1] <= 0){
                  infected_cycle[country] = current_cycle;
                  infected_from[country] = pertner;
                  infected_already[country] = true;
                }
              }
              else{
                temp_case = 0;
              }
            }
          }
        }
      }
      return temp_case;
    }
  }
       
  static double calc_global_deduction(int current_cycle){
    return current_cycle * global_deductor;
  }
  
  //DOMAIN OF SIMULATOR
  public static void sim(){
    
    int country;
    
    for(current_cycle = 0; current_cycle <= runcycle; current_cycle++){
      System.out.println("---------- Cycle: " + current_cycle + "---------------");
      
      if(current_cycle >= 1){
        for(country = 0; country < total_country; country++){
          origin = return_area_name(country);
          
          double temp_new_local = 0;
          double temp_new_global = 0;

          //Local Infection
          if(Infected[country][current_cycle - 1] > 0){
            temp_new_local = local_infection(country, current_cycle);
          }
          if(temp_new_local < 0){
            temp_new_local = 0;
          }
          
          //Global Infection
          temp_new_global = global_infection(country, current_cycle);
          if(temp_new_global <= 0){
            temp_new_global = 0;
          }
          
          new_Exposed[country][current_cycle] = temp_new_local + temp_new_global;
          Infected_by_local[country] = Infected_by_local[country] + temp_new_local;
          Infected_by_global[country] = Infected_by_global[country] + temp_new_global;
          
          //S --> E
          Exposed[country][current_cycle] = Exposed[country][current_cycle - 1] + new_Exposed[country][current_cycle];
          Susceptible[country][current_cycle] = Susceptible[country][current_cycle - 1] - new_Exposed[country][current_cycle];
         
          //E --> I
          if(current_cycle >= incubation_period){
            new_Infected[country][current_cycle] = new_Exposed[country][current_cycle - incubation_period];
            Infected[country][current_cycle] = Infected[country][current_cycle - 1] + new_Infected[country][current_cycle];
            Exposed[country][current_cycle] = Exposed[country][current_cycle] - new_Infected[country][current_cycle];
            Cumulative[country][current_cycle] = Cumulative[country][current_cycle - 1] + new_Infected[country][current_cycle];
          }
          else{
            new_Infected[country][current_cycle] = 0;
            Infected[country][current_cycle] = Infected[country][current_cycle - 1];
            Exposed[country][current_cycle] = Exposed[country][current_cycle];
            Cumulative[country][current_cycle] = Cumulative[country][current_cycle - 1] + new_Infected[country][current_cycle];
          }

          //I --> R
          if(current_cycle >= infection_period){
            Recovered[country][current_cycle] = Recovered[country][current_cycle - 1] + new_Infected[country][current_cycle - infection_period];
            Infected[country][current_cycle] = Infected[country][current_cycle] - new_Infected[country][current_cycle - infection_period];
          }
          else{
            Recovered[country][current_cycle] = Recovered[country][current_cycle - 1];
            Infected[country][current_cycle] = Infected[country][current_cycle];
          }
          
          double temp_total_pop = Susceptible[country][current_cycle] + Exposed[country][current_cycle] + Infected[country][current_cycle] + Recovered[country][current_cycle];
        }
      }

      Infected_30[0][current_cycle] = Infected[0][current_cycle] + Infected[1][current_cycle] + Infected[2][current_cycle] + Infected[3][current_cycle] + Infected[4][current_cycle] + Infected[5][current_cycle];
      Cumulative_30[0][current_cycle] = Cumulative[0][current_cycle] + Cumulative[1][current_cycle] + Cumulative[2][current_cycle] + Cumulative[3][current_cycle] + Cumulative[4][current_cycle] + Cumulative[5][current_cycle];
      Infected_30[1][current_cycle] = Infected[6][current_cycle];
      Cumulative_30[1][current_cycle] = Cumulative[6][current_cycle];
      Infected_30[2][current_cycle] = Infected[7][current_cycle];
      Cumulative_30[2][current_cycle] = Cumulative[7][current_cycle];

      for(int k = 3; k < 30; k++){
        Infected_30[k][current_cycle] = Infected[k + 5][current_cycle];
        Cumulative_30[k][current_cycle] = Cumulative[k + 5][current_cycle];
      }
      
      output_result_Infected(current_cycle);
      output_result_Cumulative(current_cycle);
      
    }
    
    System.out.println();
    for(country = 0; country < total_country; country++){
      origin = return_area_name(country);
      System.out.println("Cumulative " + origin + " : " + Cumulative[country][runcycle] + " : " + infected_cycle[country]);
      Ratio[country] = Cumulative[country][runcycle]/Cumulative[standard_country][runcycle];
      System.out.println("Ratio     " + origin + " : " + Ratio[country]);
      System.out.println("Infected " + origin + " from : " + return_area_name(infected_from[country]));

      Global_ratio[country] = (Infected_by_global[country]/(Infected_by_local[country] + Infected_by_global[country]));
      System.out.println("Per of Global " + origin + " : " + (100 * Global_ratio[country]) + " (global = " + Infected_by_global[country] + ")");
      System.out.println();
    }
    System.out.println();

    for(int k = 0; k < 30; k++){
      Ratio_30[k] = Cumulative_30[k][runcycle] / Cumulative_30[1][runcycle];
    }
    Global_ratio_30[0] = (Infected_by_global[0] + Infected_by_global[1] + Infected_by_global[2] + Infected_by_global[3] + Infected_by_global[4] + Infected_by_global[5]) / (Infected_by_local[0] + Infected_by_local[1] + Infected_by_local[2] + Infected_by_local[3] + Infected_by_local[4] + Infected_by_local[5] + Infected_by_global[0] + Infected_by_global[1] + Infected_by_global[2] + Infected_by_global[3] + Infected_by_global[4] + Infected_by_global[5]);
    Infected_cycle_30[0] = infected_cycle[5];
    for(int k = 1; k < 30; k++){
      Global_ratio_30[k] = Global_ratio[k + 5];
      Infected_cycle_30[k] = infected_cycle[k + 5];
    }
    
  }
  
  //DOMAIN OF INPUT----------------------------------------------------------------------
  public static void input_num() { 
    int i = 0, j = 0;
    String line;

    try{
      FileReader inFile = new FileReader("Data/Travelers.txt");
      BufferedReader inBuffer = new BufferedReader(inFile);

      i = 0;
      j = 0;
      while((line = inBuffer.readLine()) != null) {
        travelers[i][j] = Double.parseDouble(line);
        travelers[i][j] = (double)travelers[i][j];
        i++;
        if(i == total_country){
          j++;
          i = 0;
        }
      }
      inBuffer.close();
    }
    catch(IOException e) {
    }

    try{
      FileReader inFile = new FileReader("Data/Area.txt");
      BufferedReader inBuffer = new BufferedReader(inFile);

      i = 0;
      j = 0;
      while((line = inBuffer.readLine()) != null) {
        area[i] = Double.parseDouble(line);
        i++;
      }
      inBuffer.close();
    }
    catch(IOException e) {
    }

    try{
      FileReader inFile = new FileReader("Data/Population.txt");
      BufferedReader inBuffer = new BufferedReader(inFile);

      i = 0;
      j = 0;
      while((line = inBuffer.readLine()) != null) {
        pop[i] = Double.parseDouble(line);
        i++;
      }
      inBuffer.close();
    }
    catch(IOException e) {
    }

    for(i = 0; i < total_country; i++){
      density[i] = (double)pop[i] / (double)area[i];
    }
  
    for(i = 0; i < total_country; i++){
      origin = return_area_name(i);

      for(j = 0; j < runcycle; j++){
        local_prob[i][j] = c1 * density[i] + c2;
      }
      
      for(j = 0; j < total_country; j++){
        destination = return_area_name(j);
      }
    }
    try{
      FileReader inFile = new FileReader("Data/Timing.txt");
      BufferedReader inBuffer = new BufferedReader(inFile);

      i = 0;
      j = 0;
      while((line = inBuffer.readLine()) != null) {
        infected_cycle[i] = Integer.parseInt(line);
        i++;
      }
      inBuffer.close();
    }
    catch(IOException e) {
    }
  }

  public static String return_area_name(int i){
    String area_name;
    
    switch(i){
    case 0:
      area_name = "Beijing";
      break;
    case 1:
      area_name = "Tianjin";
      break;
    case 2:
      area_name = "Hebei";
      break;
    case 3:
      area_name = "Shanxi";
      break;
    case 4:
      area_name = "Inner Mongolia";
      break;
    case 5:
      area_name = "Guangdong";
      break;
    case 6:
      area_name = "Hong Kong";
      break;
    case 7:
      area_name = "Taiwan";
      break;
    case 8:
      area_name = "Canada";
      break;
    case 9:
      area_name = "Phillipines";
      break;
    case 10:
      area_name = "Singapore";
      break;
    case 11:
      area_name = "Viet Nam";
      break;
    case 12:
      area_name = "Australia";
      break;
    case 13:
      area_name = "France";
      break;
    case 14:
      area_name = "Germany";
      break;
    case 15:
      area_name = "India";
      break;
    case 16:
      area_name = "Indonesia";
      break;
    case 17:
      area_name = "Ireland";
      break;
    case 18:
      area_name = "Italy";
      break;
    case 19:
      area_name = "Japan";
      break;
    case 20:
      area_name = "Korea, Rep";
      break;
    case 21:
      area_name = "Kuwait";
      break;
    case 22:
      area_name = "Macao";
      break;
    case 23:
      area_name = "Malaysia";
      break;
    case 24:
      area_name = "Mongolia";
      break;
    case 25:
      area_name = "New Zealand";
      break;
    case 26:
      area_name = "Romania";
      break;
    case 27:
      area_name = "Russia";
      break;
    case 28:
      area_name = "South Africa";
      break;
    case 29:
      area_name = "Spain";
      break;
    case 30:
      area_name = "Sweden";
      break;
    case 31:
      area_name = "Swiss";
      break;
    case 32:
      area_name = "Thailand";
      break;
    case 33:
      area_name = "UK";
      break;
    case 34:
      area_name = "US";
      break;
    default:
      area_name = "ERROR";
      break;
    }
    return area_name;
  }

  //DOMAIN OF OUTPUT---------------------------------------------------------------------
  public static void plot_graphs() {
    Graph_plot_transition plot = new Graph_plot_transition(30, runcycle, 0, 1, 2, Cumulative_30);
    Graph_plot_transition plot2 = new Graph_plot_transition(30, runcycle, 0, 1, 2, Infected_30);
    Graph_plot_ratio plot3 = new Graph_plot_ratio(30, 1, Ratio_30, Global_ratio_30, Infected_cycle_30);
    Graph_plot_ratio_all plot4 = new Graph_plot_ratio_all(30, 1, Ratio_30, Global_ratio_30, Infected_cycle_30);
  }

  public static void output_result_Infected(int current_cycle){
    BufferedWriter out = null;
    PrintWriter writer = null;
    int i;
    
    try {
      writer = new PrintWriter(new BufferedWriter(new FileWriter("Output_result_infectious.txt", true)));
      String line;
      writer.print(current_cycle);
      writer.print('\t');
      
      for(i = 0; i < 30; i++){
        writer.print(Infected_30[i][current_cycle]);
        writer.print('\t');
      }
      writer.println();
    } catch (FileNotFoundException e) {
    } catch (IOException e) {
    } finally {
      try {
        if (writer != null) {
          writer.flush();
          writer.close();
        }
      } catch (Exception e) {
      }
    }
    
    out = null;
    writer = null;
  }
  
  public static void output_result_Cumulative(int current_cycle){
    BufferedWriter out = null;
    PrintWriter writer = null;
    int i;
    
    try {
      writer = new PrintWriter(new BufferedWriter(new FileWriter("Output_result_Cumulative.txt", true)));
      String line;
      writer.print(current_cycle);
      writer.print('\t');
      
      for(i = 0; i < 30; i++){
        writer.print(Cumulative_30[i][current_cycle]);
        writer.print('\t');
      }
      writer.println();
    } catch (FileNotFoundException e) {
    } catch (IOException e) {
    } finally {
      try {
        if (writer != null) {
          writer.flush();
          writer.close();
        }
      } catch (Exception e) {
      }
    }
    
    out = null;
    writer = null;
  }
}
